/***************************************************************************
                          smplsnd.h  -  description
                             -------------------
    begin                : Wed Jun 26 2002
    copyright            : (C) 2002 by Nobuhiro Kuroiwa
    email                : nobu@iastate.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SMPLSND_H
#define SMPLSND_H

#include <string>
#include <list>
#include "SDL/SDL.h"
#include "SDL/SDL_mixer.h"

#define	AUDIO_FREQUENCY			22050
#define	AUDIO_FORMAT			AUDIO_S16
#define	AUDIO_BUFFERSIZE  		512
#define	AUDIO_MODE				2
#define	AUDIO_DEFAULT_ANGLE   	0
#define	AUDIO_DEFAULT_DISTANCE  100
/**
  *@author Nobuhiro Kuroiwa
  */
using namespace std;

class ChunkAndName
{
public:
	ChunkAndName();
	ChunkAndName( Mix_Chunk *new_chunk, string *pstr);
	string		chunkname;
	Mix_Chunk	*chunk;
};

class ChunkBank
{
public:
	ChunkBank();
	Mix_Chunk	*getChunk( string *pstr_name);
	bool		assignChunk( Mix_Chunk *new_chunk, string *pname);

private:
	list<ChunkAndName>				lst_chunkandname;
	list<ChunkAndName>::iterator	it_chunkandname;
};

class SimpleSound {
public: 
	SimpleSound();
	~SimpleSound();
	bool play();
	bool load( string *pnameoffile);
	void setPosition( Sint16 new_angle, Uint8 new_dist);

private:
	string		filename;
	int			audio_frequency;
	Uint16		audio_format;
	int			audio_mode;
	int			audio_buffersize;
	Mix_Chunk	*paudio_chunk;
	Sint16		angle;
	Uint8		distance;
	bool		mychunk;
};



#endif
