/***************************************************************************
                          stranlz.cpp  -  description
                             -------------------
    begin                : Tue Jun 25 2002
    copyright            : (C) 2002 by Nobuhiro Kuroiwa
    email                : nobu@iastate.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <list>
#include <fstream>
#include "stranlz.h"


//---------------------------------------------------------------------------
//	EraseSpace( string pointer_to_source)
//	Right now, this function returns false when the pointer_to_source
//	doesn't contain double quoted word.
//	Need to be fixed later.
//---------------------------------------------------------------------------
bool eraseSpace( string *psrc)
{
	unsigned int counter = 0;
	std::list<string> lst_str;
	bool oddlistquote = false;

	//-------------------------------------------------------------------------
	//	Devide the string into quoted word and non-quoted word.
	//	"a"bc"d"=> a bc d
	//-------------------------------------------------------------------------
	if( !devideStringByStringEx( psrc, "\"", &lst_str, false))
	{
		cout << "Error in eraseSpace() : Unable to divide \"" << *psrc << "\" by \"\"\"" << endl;
		return false;
	}

	//-------------------------------------------------------------------------
	//	Words are devided but the quoted word lost double quotation during
	//	the process. So put the double quotation buck.
	//-------------------------------------------------------------------------
	if( (*psrc)[0] == '\"')	oddlistquote = true;
		
	std::list<string>::iterator itor = lst_str.begin();
	while( itor != lst_str.end())
	{
		if( counter%2 != (unsigned int)oddlistquote)
		{
			(*itor).insert(0, "\"");
			(*itor).append( "\"");
		}
		else
		{
			eraseString( &(*itor), " ");
			eraseString( &(*itor), "\t");
		}
		itor++;
		counter++;
	}
	//-------------------------------------------------------------------------
	//	Connect everything together.
	//-------------------------------------------------------------------------
	itor = lst_str.begin();
	string sophisticated;
	while( itor != lst_str.end())
	{
		sophisticated += *itor;
		itor++;
	}
  psrc->assign( sophisticated);
	return true;
}
//---------------------------------------------------------------------------
//	eraseString
//	Erase specific char seaquence in the string
//---------------------------------------------------------------------------
void eraseString( string *psrc, char *pchars)
{
	string letters( pchars);
	eraseString( psrc, &letters);
}
//---------------------------------------------------------------------------
//	eraseString
//	Erase specific string in a string
//---------------------------------------------------------------------------
void	eraseString( string *psrc, string *pletter)
{
	unsigned int space = psrc->find( *pletter);
	while( space != string::npos)
	{
		psrc->erase( space, 1);
		space = psrc->find( *pletter);
	}
}

//---------------------------------------------------------------------------
//	countString counter number of certain char string *pchar_sample in
//	the string *psrc
//---------------------------------------------------------------------------
unsigned int countString( string *psrc, char *pchar_sample)
{
	string str_sample( pchar_sample);

	return countString( psrc, &str_sample);
}	
//---------------------------------------------------------------------------
//	countString counter number of certain string *psample in
//	the string *psrc
//---------------------------------------------------------------------------
unsigned int countString( string *psrc, string *psample)
{

	unsigned int num_of_sample	= 0;
	string::size_type	pos		= 0;
	pos = psrc->find( *psample, pos);
	while( pos != string::npos)
	{
		num_of_sample++;
		pos = psrc->find( *psample, pos + 1);

	}
	return num_of_sample;
}
//---------------------------------------------------------------------------
//	devideStringByStringEx() devides string by certain seaquence of string.
//	Before use this function, most out of parenthesis must be pealed out.
//---------------------------------------------------------------------------
bool devideStringByStringEx(
	string *pstr_src, char *pchar_clv, list<string> *plst_str, bool care_parenthesis
)
{
	string str_clv( pchar_clv);
	return devideStringByStringEx( pstr_src, &str_clv, plst_str, care_parenthesis);
}
//---------------------------------------------------------------------------
//	devideStringByStringEx() devides string by certain seaquence of string.
//	Before use this function, most out of parenthesis must be pealed out.
//---------------------------------------------------------------------------
bool devideStringByStringEx(
	string *pstr_src, string *pstr_clv, list<string> *plst_str, bool care_parenthesis
)
{
	string::size_type	clv_pos	= 0;
	string::size_type	clv_old	= 0;
	string::size_type	head		= 0;
	string				str_candidate;

	//-------------------------------------------------------------------------
	//	Set initial position of seaquence we need
	//-------------------------------------------------------------------------
	clv_pos = pstr_src->find( *pstr_clv, 0);
	//-------------------------------------------------------------------------
	//	If the seaquence is starting from cleavage
	//-------------------------------------------------------------------------
  if( clv_pos == 0)
	{
		head = 1;
		//-----------------------------------------------------------------------
		//	If seaquence is only cleavage
		//-----------------------------------------------------------------------	
		if( head >= pstr_src->length())	return false;
		clv_pos = pstr_src->find( *pstr_clv, 1);
 	}
  while( clv_pos != string::npos)
	{
		//-----------------------------------------------------------------------
		//	Examine if the seaquence we are cutting out is middle of parenthesis.
		//	ex) pstr_clv = "a:(A:B=C:D):b", cleavage = ":"
		//	This part is examining (A:B=C:D), we want to ignore (A:B=C:D)
		//	What we want is "a" + "(A:B=C:D)" + "b"
		//-----------------------------------------------------------------------
		str_candidate =  pstr_src->substr( head, clv_pos - head);
		//-----------------------------------------------------------------------
		//	If the number of '(' and ')' are different in candidate, The cleavage
		//	is middle of parenthesis. We should search next candidate.
		//-----------------------------------------------------------------------		
		if(
			countString( &str_candidate, "(") == countString( &str_candidate, ")") ||
			care_parenthesis == false
		)
		{
			plst_str->push_back( str_candidate);
			head	= pstr_clv->length() + clv_pos;
			clv_old	= clv_pos;
		}
		clv_pos = pstr_src->find( *pstr_clv, clv_pos + 1);
	}
	if( clv_old + pstr_clv->length() < pstr_src->length())
	{
    plst_str->push_back( pstr_src->substr( head, pstr_src->length() - head));
	}
	return true;
}
//---------------------------------------------------------------------------
//	pealParenthesis() erases most out parenthesis in target string *str
//---------------------------------------------------------------------------
void pealParenthesis( string *pstr)
{
	string::size_type	pos_first	= pstr->find( '(');
	string::size_type	pos_last	= pstr->rfind( ')');
	string sample;
	string::size_type	pos_nonspace;

	if( pos_first	== string::npos)	return;
	if( pos_last	== string::npos)	return;
	if( pos_last - pos_first < 2)		return;

	//-------------------------------------------------------------------------
	//	If '(' comes top of the seaquence and ')' comes last of the seaquence..
	//-------------------------------------------------------------------------	
	if( !(pos_first == 0 && pos_last == pstr->length() - 1))
	{
		//-----------------------------------------------------------------------
		//	If non-space comes before '('. return
		//-----------------------------------------------------------------------	
		sample			= pstr->substr( 0, pos_first);
		pos_nonspace	= sample.find_first_not_of( ' ');
		if( pos_nonspace != string::npos)	return;
		//-----------------------------------------------------------------------
		//	If non-space comes after ')'. return
		//-----------------------------------------------------------------------
		if( pos_last >= pstr->length())		return;	
		sample		= pstr->substr(
									pos_last + 1,
									pstr->length() - pos_last + 1 + 1
						);
		pos_nonspace= sample.find_first_not_of( ' ');
		if( pos_nonspace != string::npos)	return;
	}
	*pstr = pstr->assign( pstr->substr( pos_first + 1, pos_last - 1 - pos_first));
}

bool devideDevided(
					string			*pstr_src,
					char			*pchar_clv_high,
					char			*pchar_clv_low,
					list<StrLst>	*plst_lst_str
)
{
	string str_clv_high	= pchar_clv_high;
	string str_clv_low	= pchar_clv_low;
	return devideDevided( pstr_src, &str_clv_high, &str_clv_low, plst_lst_str);
}

//---------------------------------------------------------------------------
//	defideDevided devides string which devided by certain string.
//---------------------------------------------------------------------------
bool devideDevided(
					string			*pstr_src,
					string			*pstr_clv_high,
					string			*pstr_clv_low,
					list<StrLst>	*plst_lst_str
)
{
	list<StrLst>			lst_lst_str;
 	list<string>			lst_str_high, lst_str_low;
	list<string>::iterator	it_str_high;
	string					str_h;

	if( !devideStringByStringEx( pstr_src, pstr_clv_high, &lst_str_high, true))
		return false;

	it_str_high = lst_str_high.begin();
	while( it_str_high != lst_str_high.end())
	{
		str_h = *it_str_high++;
		pealParenthesis( &str_h);
		if( !devideStringByStringEx( &str_h, pstr_clv_low, &lst_str_low, true))
			return false;
		plst_lst_str->push_back( lst_str_low);
		lst_str_low.clear();
	}
	return true;
}

//---------------------------------------------------------------------------
//	Test if the string is number or not.
//---------------------------------------------------------------------------
bool isNumber( string *pstr)
{
	unsigned int counter;
	for( counter = 0; counter < pstr->length(); counter++)
	{
		if( (*pstr)[counter] < 0x030 || 0x039 < (*pstr)[counter])
			return false;
	}
	return true;
}

//---------------------------------------------------------------------------
//	loadFile loads file whose name is *pstr_filename. and the contents of
//	file are loaded into string *pstr_save.
//---------------------------------------------------------------------------
bool loadFile( string *pstr_filename, string *pstr_save)
{
	std::fstream	fin;
	fin.open( pstr_filename->data(), std::ios::in);
	if( !fin.is_open())
	{
		cout << "Unable to Open file \"" << *pstr_filename << "\"" << endl;
		return false;
	}
	std::getline( fin, *pstr_save, '\0');
	fin.close();
	return true;
}
//---------------------------------------------------------------------------
//	loadFile loads file whose name is *pchar_filename. and the contents of
//	file are loaded into string *pstr_save.
//---------------------------------------------------------------------------
bool loadFile( char *pchar_filename, string *pstr_save)
{
	string str_filename = pchar_filename;
	return loadFile( &str_filename, pstr_save);
}

//---------------------------------------------------------------------------
//	devideStringByA2B() devides string seaquence by interval of *pstr_clv1 to
//	*pstr_clv2.
//---------------------------------------------------------------------------
void devideStringByA2B( string *pstr_src, string *pstr_clv1, string *pstr_clv2, list<string> *plst_str)
{
	string::size_type	head;
	string::size_type	tail;
	string				clvf;
	string::size_type	oldtail;
	int					counter	= 0;

	head = pstr_src->find( *pstr_clv1);
	if( head == string::npos)
	{
		plst_str->push_back( *pstr_src);
		return;
	}
	//-------------------------------------------------------------------------
	//	If the comments line doesn't comes top of the seaquence. Store the
	//	string which is located before first comment line. 	
	//-------------------------------------------------------------------------
	if( head != 0)
	{
		//cout << "head != 0" << endl;
		plst_str->push_back( pstr_src->substr( 0, head));
	}

	head += pstr_clv1->length();

	// assume line should be starting from clv1
	while( true)
	{
		//-----------------------------------------------------------------------
		//	Flip the string between string which represents starting of comment
		//	and end of comment.
		//-----------------------------------------------------------------------
		if( counter % 2 == 0)	clvf = *pstr_clv2;// Oddth	finding clv2
		else					clvf = *pstr_clv1;// Eventh	finding clv1

		//-----------------------------------------------------------------------
		//	Update tail and save current value as oldtail which might be needed
		//	when tail == npos and break this loop.
		//-----------------------------------------------------------------------
		oldtail = tail;
		tail = pstr_src->find( clvf, head);
		if( tail == string::npos)	break;

		//-----------------------------------------------------------------------
		//	Cut off the string between head and tail
		//	Then update head.
		//-----------------------------------------------------------------------
		plst_str->push_back( pstr_src->substr( head, tail - head));
		head = tail + clvf.length();
		counter++;
	}

	//-------------------------------------------------------------------------
	//	If there is still string remains, save it.
	//-------------------------------------------------------------------------
	if( oldtail + clvf.length() < pstr_src->length())
	{
		plst_str->push_back(
			pstr_src->substr(
				oldtail + clvf.length() - 1,	pstr_src->length() - (oldtail + clvf.length())
			)
		);
	}
}

//---------------------------------------------------------------------------
//	devideStringByA2B() devides string seaquence by interval of *pchar_clv1 to
//	*pchar_clv2.
//---------------------------------------------------------------------------
void devideStringByA2B( string *pstr_src, char *pchar_clv1, char *pchar_clv2, list<string> *plst_str)
{
	string str_clv1 = pchar_clv1;
	string str_clv2 = pchar_clv2;
	devideStringByA2B( pstr_src, &str_clv1, &str_clv2, plst_str);
}

//---------------------------------------------------------------------------
//	eraseComment() erases comment line which is surrounded // and \n.
//---------------------------------------------------------------------------
void eraseComment( string *pstr)
{
	list<string>			lst_str;
	list<string>::iterator	it;
	string::size_type		pos;
	string					strtemp;

	bool comment1st = true;
	//-------------------------------------------------------------------------
	//	if // comes top of the seaquence, the top of the list lst_str stores
	//	comments line. Odd number of list components are comment which we don't
	//	need.
	//-------------------------------------------------------------------------
	pos = pstr->find( "//");
	if( pos != 0)	comment1st = false;

 	//-------------------------------------------------------------------------
	//	Erasing space. This doesn't erase '\n' as old version does.	
	//-------------------------------------------------------------------------
	//eraseSpace( pstr);	// new version doesn't erase '\n'

 	//-------------------------------------------------------------------------
	//	Deviding pstr into comments and non-coimments.	
	//-------------------------------------------------------------------------
	devideStringByA2B( pstr, "//", "\n", &lst_str);

	//-------------------------------------------------------------------------
	//	Erase '\n'
	//-------------------------------------------------------------------------
	unsigned int counter;
	unsigned int size = lst_str.size();
	for( counter = 0; counter < size; counter++)
	{
		it		= lst_str.begin();// never be it = lst_str.end()
		strtemp = *it;

		eraseString( &strtemp, "\n");

		lst_str.pop_front();
		lst_str.push_back( strtemp);
	}

	//-------------------------------------------------------------------------
	//	Connecting non comment lines. Comments lines are skipped.
	//-------------------------------------------------------------------------
	strtemp = string();
	it = lst_str.begin();
	counter = 0;
	while( it != lst_str.end())
	{
		if( counter % 2 == (unsigned int)comment1st)	strtemp.append( *it);
		it++;
		counter++;
	}
  *pstr = strtemp;
}

/*
void testEraseComment()
{
	string line;
	loadFile( "playlist.txt", &line);
	eraseComment( &line);
	cout << "result-------------------" << endl;
	cout << line << endl;
}

void testDevideStringA2B2()
{
	//string line = "abcdABCefghDEFijk";
	//string line = "ABCabDEFcdeABCfghijkDEF";
	//string line = "ABCaaaDEFbbbABCcccDEFeee";
	//string line = "//ablncde//fghijkln";
	//string line = "//aaalnbbb//ccclneee";
	//string line = "//ln//aaalnbblnb//cccln";
	//string line = "//lnaaa//lnbbbln";
	//string line = "//lnabc";
	//string line = "abc//lndef";
	string line;
  string clv1 = "//";
	string clv2 = "\n";
	list<string>	lst_str;
	list<string>::iterator it;
  string strtemp;
  loadFile( "playlist.txt", &line);
	cout << "line is           ----------------------\n" << line << endl;
	eraseSpace( &line);
	cout << "line w/o space is ----------------------\n" << line << endl;
  devideStringByA2B( &line, &clv1, &clv2, &lst_str);

	int counter;
	int size = lst_str.size();
	for( counter = 0; counter < size; counter++)
	{
	  it = lst_str.begin();// never be it = lst_str.end()
		strtemp = *it;
		eraseString( &strtemp, "\n");
		//cout << "the string is \n" << *it << endl;
		lst_str.pop_front();
		lst_str.push_back( strtemp);
	}
	cout << "line result is    ----------------------\n" << endl;

	it = lst_str.begin();
	while( it != lst_str.end())
	{
		cout << "\""<< *it++ << "\"" << endl;
		cout << "-----------------------" << endl;
	}
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void testPealParenthesis()
{
	//string line = "aa(bbcc)";
	//string line = "(abc)";
	//string line = "(ab)c";
	//string line = "(a)";
	//string line = " (a) ";
	string line = " )a(";
	cout << line << endl;
	pealParenthesis( &line);
	cout << ">" << line << "<" << endl;
}	
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void testCountString()
{
	//string line = "aaa---aaa-aaa-aaa";
	string line = "---aaa-aaa-aaa";
	string sample = "aaa";
	cout << line << " contains " << countString( &line, "aaa") << " of " << sample << endl;;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void testDevideStringByStringEx()
{
	//string line = "a:(b:c=d:e)";
	//string line = "(a:b:(c1:c2=C1:C2)=1:2:3):(d:e=4:5):(f:g:e=6:7:8)";
	//string cleavage = ":";

	//string line = "(a:b=1:2),3";
	string line = "(a:b=1:2),\"ho ge.wav\"";
	string cleavage = ",";
	list<string> lst_str;
	list<string>::iterator it;
	devideStringByStringEx( &line, &cleavage, &lst_str, true);
	it = lst_str.begin();
	while( it != lst_str.end())
	{
		cout << *it++ << endl;
	}
	cout << "size of list is " << lst_str.size() << endl;
}
*/
//---------------------------------------------------------------------------
	//-------------------------------------------------------------------------
		//-----------------------------------------------------------------------
			//---------------------------------------------------------------------

